/* 
***************************************************
Asignatura: Tecnologías Web
Titulación: GIITIN
Autor     : Enrique
Universidad de Oviedo
***************************************************
*/
/*
 * 
 * 
 * Definicion de las funciones auxiliares para el CRUD (Alta, Baja, Edicion y Listado)
 * 
 * 
 */
$(function(){
	//Código de operacion (Alta o Edicion)
	var operation = "A"; //"A"=Adding; "E"=Editing
	//Indice del elemento seleccionado
	var selected_index = -1; //Index of the selected list item
    //Recuperamos la tabla de alumnos anterior (si la hubiere)
	var tbAlumnos = localStorage.getItem("tbAlumnos");
    //La parseamos a formato Objeto
	tbAlumnos = JSON.parse(tbAlumnos); //Converts string to object
    //Sino no existiera previamente la tabla, se inicia a un array vacio.
	if(tbAlumnos == null) 
		tbAlumnos = [];
	// Se genera listado de los alumnos existentes en el almacenamiento local al principio.
	List();

	//Alta de un nuevo alumno
	function Add(){
		//Preparamos el registro de un alumno
		var alumno = JSON.stringify({
			ID        : $("#txtID").val(),
			IDUser    : $("#txtIDUser").val(),
			Nombre    : $("#txtNombre").val(),
			Apellidos : $("#txtApellidos").val(),
			Email     : $("#txtEmail").val(),
			Ciudad 	  : $("#txtCiudad").val(),
			Direccion : $("#txtDireccion").val()
		});
		//Añadimos al almacenamiento Web un alumno
		tbAlumnos.push(alumno);
		//Reescribimos la variable "tbAlumnos" del almacenamiento web.
		localStorage.setItem("tbAlumnos", JSON.stringify(tbAlumnos));
		//Mostramos un mensaje de confirmación del alta de alumno
		alert("Alumno dado de alta.");		
	}
    //Edicion de un alumno existente
	function Edit(){
		alumno = JSON.stringify({
			ID        : $("#txtID").val(),       //#txtID -> etiqueta Json para la propiedad ID
			IDUser    : $("#txtIDUser").val(),
			Nombre    : $("#txtNombre").val(),
			Apellidos : $("#txtApellidos").val(),
			Email     : $("#txtEmail").val(),
			Ciudad 	  : $("#txtCiudad").val(),
			Direccion : $("#txtDireccion").val()
		}); //Se sobreescribe el elemento a editado sobre la table "tbAlumnos"
		tbAlumnos[selected_index] = alumno;
		//Reescribimos la variable "tbAlumnos" del almacenamiento web.
		localStorage.setItem("tbAlumnos", JSON.stringify(tbAlumnos));
		alert("Alumno modificado.");
		operation = "A"; //Se retorna el valor por defecto
	}
    //Eliminación de un alumno existente
	function Delete(){
		//se elimina la posición del alumno a eliminar (selected_index)
		tbAlumnos.splice(selected_index, 1);
		//Reescribimos la variable "tbAlumnos" del almacenamiento web.
		localStorage.setItem("tbAlumnos", JSON.stringify(tbAlumnos));
		alert("Alumno eliminado.");
	}
    //Lista de alumnos
	function List(){		
		$("#tblList").html("");
		$("#tblList").html(
			"<thead>"+
			"	<tr>"+
			"	<th></th>"+
			"	<th>ID</th>"+
			"	<th>IDUser</th>"+
			"	<th>Nombre</th>"+
			"	<th>Apellidos</th>"+
			"	<th>Email</th>"+
			"   <th>Ciudad</th>"+
			"   <th>Direccion</th>"+
			"	</tr>"+
			"</thead>"+
			"<tbody>"+
			"</tbody>"
			);
		for(var i in tbAlumnos){
			var alumno = JSON.parse(tbAlumnos[i]);
		  	$("#tblList tbody").append("<tr>"+
									 	 "	<td><img src='icons/edit.png' alt='Editar"+i+"' class='btnEdit'/><img src='icons/delete.png' alt='Borrar"+i+"' class='btnDelete'/></td>" + 
										 "	<td>"+alumno.ID+"</td>" + 
										 "	<td>"+alumno.IDUser+"</td>" + 
										 "	<td>"+alumno.Nombre+"</td>" + 
										 "	<td>"+alumno.Apellidos+"</td>" + 
										 "	<td>"+alumno.Email+"</td>" + 
										 "	<td>"+alumno.Ciudad+"</td>" + 
										 "	<td>"+alumno.Direccion+"</td>" + 										 
		  								 "</tr>");
		}
	
	}
	
	function Add_alumno(alumno) {
		//Calculamos el número de filas del cuerpo de la tabla
		i = $("#tblList tbody").size()+1;
		//Añadimos una nueva fila con el numero de fila size()+1
		$("#tblList tbody").append("<tr>"+
			 	 "	<td><img src='icons/edit.png' alt='Editar"+i+"' class='btnEdit'/><img src='icons/delete.png' alt='Borrar"+i+"' class='btnDelete'/></td>" + 
				 "	<td>"+alumno.ID+"</td>" + 
				 "	<td>"+alumno.IDUser+"</td>" + 
				 "	<td>"+alumno.Nombre+"</td>" + 
				 "	<td>"+alumno.Apellidos+"</td>" + 
				 "	<td>"+alumno.Email+"</td>" + 
				 "	<td>"+alumno.Ciudad+"</td>" + 
				 "	<td>"+alumno.Direccion+"</td>" + 										 
					 "</tr>");	
	}
    //Manejador del evento onsubmit del formulario formAlumno
	$("#frmCRUDAlumnos").bind("submit",function(event){		
		if(operation == "A")
			Add();
		else
			Edit();
		//Si metemos el List aqui hay que evitar el evento por defecto para que no se pinte
		//dos veces (el evento por defecto para submit es cargar la pagina otra vez y enviar el formulario y reiniciarlo a campos vacios.
		//Debemos eligir 
		//1 Poner el List aqui ademas del evento.preventDefault 
		//2 o dejar que se haga al principio y no ponerlo aqui.
		//El problema de la opcion 1 es que el formulario no se va a iniciar a vacio cada vez
		//que pulsemos submit (tendremos que hacerlo nosotros por código): $("#frmCRUDAlumnos").reset();
		
		//Listamos la tabla del web storage sobre la tabla con los datos actualizados
		List();
		//Prevenimos el evento por defecto para el evento submit (que consiste en enviar los datos del formulario y recargar 
		//la página.
	    event.preventDefault();	
		//Limpiamos el formulario	
	    // Hay que recurrir al elemento 0 para aplicar reset.
		$("#frmCRUDAlumnos")[0].reset();
		$('#txtID').removeAttr('readonly');
	});
	
	/*
	 * 
	 * Empieza el programa
	 * 
	 */

	//Manejador del evento onclick del enlace btnEdit
	//hay que seleccionar #tblList porque al eliminar el elemento 
	//la segunda vez  JQuery no encuentra el camino al elemento a borrar al haber
	//cambiado los objetos al llamar List().
	$("#tblList").on("click", ".btnEdit", function(event){
	//$(".btnEdit").on("click", function(event){
        //Ponemos el estado de operacion 'E' para que al salvar el formulario 
		//de alta/edición se considere la operación edición
		operation = "E";
		//Obtenemos el ID del alumno del atributo "alt" correspondiente al botón/imagen "Editar"
		//para ello reemplazamos el texto "Editar" por "", quedando sólo el número.
		selected_index = parseInt($(this).attr("alt").replace("Editar", ""));
        //Obtenemos los datos del alumnos del array tbAlumnos
		var alumno = JSON.parse(tbAlumnos[selected_index]);
		//Pintamos los datos alumnos sobre el formularios de alta/edición
		$("#txtID").val(alumno.ID);
		$("#txtIDUser").val(alumno.IDUser);
		$("#txtNombre").val(alumno.Nombre);
		$("#txtApellidos").val(alumno.Apellidos);
		$("#txtEmail").val(alumno.Email);
		$("#txtCiudad").val(alumno.Ciudad);
		$("#txtDireccion").val(alumno.Direccion);		
		$("#txtID").attr("readonly","readonly");   //Esta propiedad es de solo lectura
		$("#txtNombre").focus();                   //Ponemos el foco en el campo Nombre.
		//Para esto evento nos da igual eliminar el evento por defecto o no.
		//ya que el evento no afecta a ready() 
		//Prevenimos el evento por defecto para el evento click (que consiste en enviar los datos del formulario y recargar 
		//la página.
	    //event.preventDefault();
	});
	
	//Manejador del evento onclick del enlace btnDelete
	//$(".btnDelete").on("click",  function(){
	//hay que seleccionar #tblList porque al eliminar el elemento 
	//la segunda vez que JQuery no encuentra el camino al elemento a borrar al haber
	//cambiado los objetos al llamar List().  
	$("#tblList").on("click", ".btnDelete", function(event) {
		//Obtenemos el ID del alumno del atributo "alt" correspondiente al botón/imagen "Borrar"
		//para ello reemplazamos el texto "Borrar" por "", quedando sólo el número.
		selected_index = parseInt($(this).attr("alt").replace("Borrar", ""));
		//Borramos el alumno seleccionado sobre el icono de borrado
		Delete();
		//Volvemos a listar los alumnos restantes para que desaparezca el eliminado
		List();
		//Para esto evento nos da igual eliminar el evento por defecto o no.
		//ya que el evento no afecta a ready() 
		//Prevenimos el evento por defecto para el evento click (que consiste en enviar los datos del formulario y recargar 
		//la página.
	    //event.preventDefault();
	});		
});
