/** 
***************************************************
Asignatura: Tecnologías Web
Titulación: GIITIN
Autor     : Enrique
Universidad de Oviedo
***************************************************
**/
/**
 * 
 * Inicializaciones
 * 
 */
//Objeto de geoposicionamiento
var geocoder; 
//Flag para obtener el mapa de googlemaps sólo para la primera invocación de codeAddress
var primero = true;
//Mapa donde se va a pintar 
var map;
//Recuperamos la tabla de alumnos anterior (si la hubiere)
var tbAlumnos = localStorage.getItem("tbAlumnos");
//La parseamos a formato Objeto
tbAlumnos = JSON.parse(tbAlumnos); //Converts string to object
//Sino existiera previamente la tabla, se inicia a un array vacio.
if(tbAlumnos == null) 
	tbAlumnos = [];
/**
 * 
 * Función de inicialización de objetos dinámicos y llamadas de inicio
 * 
 */
function Inicializar()
{
	//Inicializamos geocoder	
	geocoder = new google.maps.Geocoder();
	//Creamos el mapa y nos  centramos en Asturias  
	codeAddress("Oviedo, Asturias");	
	//Pintamos los alumnos existentes
	List();
}
/*
 * 
 * Función de geoposicionamiento.
 * 
 * @input: direccion. Dirección según el convenio de googlemaps (Direccion, Ciudad, Provincia, Pais)
 * @input: nombre. Nombre y apellidos del alumno que deseamos que aparezca en el rótulo asociado a la chincheta.
 * 
 * La primera vez que se invoca obtiene el mapa centrado en la dirección que se le pase (el segundo parámetro no se usará)y los pinta donde se le indique.
 * 			a partir de la segunda vez se encarga de pintar las chincheta del alumno que se le pase (nombre) en la direccion que se indique (direccion)
 * 
 */
function codeAddress(direccion, nombre) {
	//Conexion AjaX al servicio de geoposicionamiento de Google.
	//Enviamos la dirección y de forma asíncrona se llama a nuestra función
	//callback anonima function(results, status)
	geocoder.geocode( { 'address': direccion}, function (results, status) {
		//Si la consulta AJAX tuvo exito
		if (status == google.maps.GeocoderStatus.OK) {
			//Pintamos el mapa si se trata de la primera vez que se llama a la funcion codeAdress.
			if (primero)
			{
				primero = false;
				//Opciones para centrar el mapa en la dirección inicial
				//Nos pasarán Asturias.
				var myOptions = {
						zoom: 10,
						center: results[0].geometry.location,
						mapTypeId: google.maps.MapTypeId.ROADMAP
				};
				//Obtenemos el mapa que acabamos de pintar para usar con los alumnos (primero = false)
				map = new google.maps.Map(document.getElementById("contenido"), myOptions);
			}
			//Vamos a pintar las chinchetas marcador
			else {
				//Fijamos el centro en la direccion que nos pasan para pasarsela al marcador.
				map.setCenter(results[0].geometry.location);
				//Preparamos el objeto marcador/chincheta
				var marker = new google.maps.Marker({
					map: map, 
					position: results[0].geometry.location,
					title: results[0].formatted_address
				});
				//Obtenemos un objeto ventana informatica, para contener la información de cada alumno        
				infowindow = new google.maps.InfoWindow();
				//Añadimos al escuchador del mapa el manejador para el evento click
				//asociado al marcado de este alumno
				google.maps.event.addListener(marker, "click", function() {
					//Aqui fijamos el contenido de la ventana.
					infowindow.setContent('<div class="infoalunno">'+
							'<div class="nombre">'+nombre+'</div>'+
							'<div class="direccion">'+direccion+'</div>'+
					'</div>');
					//Aqui abrimos la ventana cuando se clicka encima del marcador.             
					infowindow.open(map, marker);
				});
			}
		} else {
			alert("Geocode no respondió correctamente por la siguiente razón: " + status);
		}
	});
}


function error() {
	console.log('Hubo en error!');
};   



//Pinta todos los alumnos sobre el mapa
function List(){	

	for(var i in tbAlumnos){
		var alumno = JSON.parse(tbAlumnos[i]);
		//Añadimos chincheta al Mapa
		var direccion = alumno.Direccion + "," + alumno.Ciudad + ", Asturias";
		var nombre = alumno.Nombre+ " "+ alumno.Apellidos;
		codeAddress(direccion, nombre);
	}


}